#include "stdafx.h"
#include "expclass.h"
#include "forcecast.h"
#include "ClassLdr.h"

namespace
{
	typedef void (A::*PfnConstructorOfA1)();
	typedef void (A::*PfnConstructorOfA2)(int);
	typedef void (A::*PfnDestructorOfA)();
	typedef void (A::*PfnSetNumOfA)(int);
	typedef int	 (A::*PfnGetNumOfA)();
}

A::A()
{
	static PfnConstructorOfA1 pfnConsA1 = force_cast<PfnConstructorOfA1>(GetProcAddress(ClassLoader<A>::s_hMod, TEXT("ConstructorOfA1")));

	(this->*pfnConsA1)();
}

A::A(int n)
{
	static PfnConstructorOfA2 pfnConsA2 = force_cast<PfnConstructorOfA2>(GetProcAddress(ClassLoader<A>::s_hMod, TEXT("ConstructorOfA2")));

	(this->*pfnConsA2)(n);
}

void A::SetNum(int n)
{
	static PfnSetNumOfA pfnSetNumA = force_cast<PfnSetNumOfA>(GetProcAddress(ClassLoader<A>::s_hMod, TEXT("SetNumOfA")));

	(this->*pfnSetNumA)(n);
}

int A::GetNum()
{
	static PfnGetNumOfA pfnGetNumA = force_cast<PfnGetNumOfA>(GetProcAddress(ClassLoader<A>::s_hMod, TEXT("GetNumOfA")));

	return (this->*pfnGetNumA)();
}

A::~A()
{
	static PfnDestructorOfA pfnDestA = force_cast<PfnDestructorOfA>(GetProcAddress(ClassLoader<A>::s_hMod, TEXT("ConstructorOfA1")));

	(this->*pfnDestA)();
}
